// https://github.com/vuejs/vue-cli/blob/dev/packages/%40vue/cli-ui/src/main.js#L12
const gql = window.gql

export const DARK_MODE = gql`
  query darkMode {
    darkMode @client
  }
`
export const CONNECTED = gql`
  query connected {
    connected @client
  }
`

export const SHARED_DATA = gql`
  fragment sharedData on SharedData {
    id
    value
  }
  query sharedData ($id: ID!, $projectId: ID!) {
    sharedData (id: $id, projectId: $projectId) {
      ...sharedData
    }
  }
`

export const DEPENDENCY_INSTALL = gql`
  fragment dependency on Dependency {
    id
    type
    installed
    website
  }

  mutation dependencyInstall ($input: DependencyInstall!) {
    dependencyInstall (input: $input) {
      ...dependency
    }
  }
`
